public interface ISongValidator
{
    Task<Song> ValidateAsync(Uri songUri);

    bool CanValidateUri(Uri songUri);

    Task<bool> CanExtractSongMetadataAsync(Uri songUri);

    SongProvider GetSongProvider();
}